module("luci.controller.asterisk",package.seeall)
function index()
entry({"admin","services","asterisk"},cbi("asterisk"),"Asterisk",80)
entry({"admin","services","asterisk","voice"},cbi("asterisk-voice"),"Voice Functions",1)
entry({"admin","services","asterisk","meetme"},cbi("asterisk-meetme"),"Meetme Conferences",2)
entry({"admin","services","asterisk","iax-conns"},cbi("asterisk-iax-connections"),"IAX Connections",3)
entry({"admin","services","asterisk","sip-conns"},cbi("asterisk-sip-connections"),"SIP Connections",4)
entry({"admin","services","asterisk","dialplans"},cbi("asterisk-dialplans"),"Dial Plans",5)
entry({"admin","services","asterisk","mod"},cbi("asterisk-mod-app"),"Modules",4)
entry({"admin","services","asterisk","mod","app"},cbi("asterisk-mod-app"),"Applications",1)
entry({"admin","services","asterisk","mod","cdr"},cbi("asterisk-mod-cdr"),"Call Detail Records",2)
entry({"admin","services","asterisk","mod","chan"},cbi("asterisk-mod-chan"),"Channels",3)
entry({"admin","services","asterisk","mod","codec"},cbi("asterisk-mod-codec"),"Codecs",4)
entry({"admin","services","asterisk","mod","format"},cbi("asterisk-mod-format"),"Format",5)
entry({"admin","services","asterisk","mod","func"},cbi("asterisk-mod-func"),"Functions",6)
entry({"admin","services","asterisk","mod","pbx"},cbi("asterisk-mod-pbx"),"PBX",7)
entry({"admin","services","asterisk","mod","res"},cbi("asterisk-mod-res"),"Resources",8)
entry({"admin","services","asterisk","mod","res","feature"},
cbi("asterisk-mod-res-feature"),"Feature Module Configuration",9)
entry({"admin","asterisk"},cbi("asterisk/main"),"Asterisk",99).i18n="asterisk"
entry({"admin","asterisk","phones"},cbi("asterisk/phones"),"Phones",1)
entry({"admin","asterisk","phones","sip"},cbi("asterisk/phone_sip"),nil,1).leaf=true
entry({"admin","asterisk","trunks"},cbi("asterisk/trunks"),"Trunks",2)
entry({"admin","asterisk","trunks","sip"},cbi("asterisk/trunk_sip"),nil,1).leaf=true
entry({"admin","asterisk","voicemail"},cbi("asterisk/voicemail"),"Voicemail",3)
entry({"admin","asterisk","voicemail","mailboxes"},cbi("asterisk/voicemail"),"Mailboxes",1)
entry({"admin","asterisk","voicemail","settings"},cbi("asterisk/voicemail_settings"),"Settings",2)
entry({"admin","asterisk","meetme"},cbi("asterisk/meetme"),"MeetMe",4)
entry({"admin","asterisk","meetme","rooms"},cbi("asterisk/meetme"),"Rooms",1)
entry({"admin","asterisk","meetme","settings"},cbi("asterisk/meetme_settings"),"Settings",2)
entry({"admin","asterisk","dialplans"},call("handle_dialplan"),"Call Routing",5)
entry({"admin","asterisk","dialplans","out"},cbi("asterisk/dialplan_out"),nil,1).leaf=true
entry({"admin","asterisk","dialplans","zones"},call("handle_dialzones"),"Dial Zones",2).leaf=true
end
function handle_dialplan()
local e=luci.model.uci.cursor()
local t=require"luci.asterisk"
local i=false
for a,o in pairs(luci.http.formvaluetable("delzone"))do
local t=t.dialplan.plan(a)
if#o>0 and t then
local a={}
for i,t in ipairs(t.zones)do
if t.name~=o then
a[#a+1]=t.name
end
end
e:delete("asterisk",t.name,"include")
if#a>0 then
e:set("asterisk",t.name,"include",a)
end
end
end
for a,o in pairs(luci.http.formvaluetable("addzone"))do
local a=t.dialplan.plan(a)
local t=t.dialzone.zone(o)
if#o>0 and a and t then
local t={t.name}
for o,a in ipairs(a.zones)do
t[#t+1]=a.name
end
e:delete("asterisk",a.name,"include")
if#t>0 then
e:set("asterisk",a.name,"include",t)
end
end
end
for o,a in pairs(luci.http.formvaluetable("delvbox"))do
local t=t.dialplan.plan(o)
if#a>0 and t then
e:delete_all("asterisk","dialplanvoice",
{extension=a,dialplan=t.name})
end
end
for a,i in pairs(luci.http.formvaluetable("addvbox"))do
local o=t.dialplan.plan(a)
local a=t.voicemail.box(i)
if o and a then
local t=luci.http.formvalue("addvboxext.%s"%o.name)
t=(t and#t>0)and t or a.number
e:section("asterisk","dialplanvoice",nil,{
dialplan=o.name,
extension=t,
voicebox=a.number,
voicecontext=a.context
})
end
end
for o,a in pairs(luci.http.formvaluetable("delmeetme"))do
local t=t.dialplan.plan(o)
if#a>0 and t then
e:delete_all("asterisk","dialplanmeetme",
{extension=a,dialplan=t.name})
end
end
for a,o in pairs(luci.http.formvaluetable("addmeetme"))do
local a=t.dialplan.plan(a)
local o=t.meetme.room(o)
if a and o then
local t=luci.http.formvalue("addmeetmeext.%s"%a.name)
t=(t and#t>0)and t or o.room
e:section("asterisk","dialplanmeetme",nil,{
dialplan=a.name,
extension=t,
room=o.room
})
end
end
local a=luci.http.formvalue("addplan")
if a and#a>0 then
if a:match("^[a-zA-Z0-9_]+$")then
e:section("asterisk","dialplan",a,{})
else
i=true
end
end
local a=luci.http.formvalue("delplan")
if a and#a>0 then
if e:get("asterisk",a)=="dialplan"then
e:delete("asterisk",a)
e:delete_all("asterisk","dialplanvoice",{dialplan=a})
e:delete_all("asterisk","dialplanmeetme",{dialplan=a})
end
end
e:save("asterisk")
t.uci_resync()
luci.template.render("asterisk/dialplans",{create_error=i})
end
function handle_dialzones()
local a=require"luci.asterisk"
local e=luci.model.uci.cursor()
local o=false
if luci.http.formvalue("newzone")then
local t=luci.http.formvalue("newzone_name")
if t and t:match("^[a-zA-Z0-9_]+$")then
e:section("asterisk","dialzone",t,{
uses=a.tools.parse_list(luci.http.formvalue("newzone_uses")or{}),
match=a.tools.parse_list(luci.http.formvalue("newzone_match")or{})
})
e:save("asterisk")
else
o=true
end
end
if luci.http.formvalue("delzone")then
local t=luci.http.formvalue("delzone")
if e:get("asterisk",t)=="dialzone"then
e:delete("asterisk",t)
e:save("asterisk")
end
end
luci.template.render("asterisk/dialzones",{create_error=o})
end
