local o=require("luci.asterisk")
local n=require("luci.model.uci").cursor()
if not arg[1]then
zonemap=Map("asterisk","Dial Zones",[[
		Dial zones hold patterns of dialed numbers to match.
		Each zone has one or more trunks assigned. If the first trunk is
		congested, Asterisk will try to use the next available connection.
		If all trunks fail, then the following zones in the parent dialplan
		are tried.
	]])
local i,t=o.dialzone.zones()
zonetbl=zonemap:section(Table,i,"Zone Overview")
zonetbl.sectionhead="Zone"
zonetbl.addremove=true
zonetbl.anonymous=false
zonetbl.extedit=luci.dispatcher.build_url(
"admin","asterisk","dialplans","zones","%s"
)
function zonetbl.cfgsections(e)
return t
end
function zonetbl.parse(a)
for e,o in pairs(a.map:formvaluetable(
luci.cbi.REMOVE_PREFIX..a.config
)or{})do
if e:sub(-2)==".x"then e=e:sub(1,#e-2)end
n:delete("asterisk",e)
n:save("asterisk")
a.data[e]=nil
for a=1,#t do
if t[a]==e then
table.remove(t,a)
break
end
end
end
Table.parse(a)
end
zonetbl:option(DummyValue,"description","Description")
zonetbl:option(DummyValue,"addprefix")
match=zonetbl:option(DummyValue,"matches")
function match.cfgvalue(t,e)
return table.concat(i[e].matches,", ")
end
trunks=zonetbl:option(DummyValue,"trunk")
trunks.template="asterisk/cbi/cell"
function trunks.cfgvalue(t,e)
return o.tools.hyperlinks(i[e].trunks)
end
return zonemap
else
zoneedit=Map("asterisk","Edit Dialzone")
entry=zoneedit:section(NamedSection,arg[1])
entry.title="Zone %q"%arg[1];
back=entry:option(DummyValue,"_overview","Back to dialzone overview")
back.value=""
back.titleref=luci.dispatcher.build_url(
"admin","asterisk","dialplans","zones"
)
desc=entry:option(Value,"description","Description")
function desc.cfgvalue(t,e,...)
return Value.cfgvalue(t,e,...)or e
end
trunks=entry:option(MultiValue,"uses","Used trunks")
trunks.widget="checkbox"
n:foreach("asterisk","sip",
function(e)
if e.provider=="yes"then
trunks:value(
"SIP/%s"%e['.name'],
"SIP/%s (%s)"%{e['.name'],e.host or'n/a'}
)
end
end)
match=entry:option(DynamicList,"match","Number matches")
intl=entry:option(DynamicList,"international","Intl. prefix matches (optional)")
aprefix=entry:option(Value,"addprefix","Add prefix to dial out (optional)")
ccode=entry:option(Value,"countrycode","Effective countrycode (optional)")
lzone=entry:option(ListValue,"localzone","Dialzone for local numbers")
lzone:value("","no special treatment of local numbers")
for t,e in ipairs(o.dialzone.zones())do
lzone:value(e.name,"%q (%s)"%{e.name,e.description})
end
lprefix=entry:option(Value,"localprefix","Prefix for local calls (optional)")
return zoneedit
end
