local a=require("luci.asterisk")
cbimap=Map("asterisk","Registered Phones")
cbimap.pageaction=false
local e={}
cbimap.uci:foreach("asterisk","sip",
function(t)
if t.type~="peer"then
t.name=t['.name']
t.info=a.sip.peer(t.name)
e[t.name]=t
end
end)
sip_table=cbimap:section(TypedSection,"sip","SIP Phones")
sip_table.template="cbi/tblsection"
sip_table.extedit=luci.dispatcher.build_url("admin","asterisk","phones","sip","%s")
sip_table.addremove=true
function sip_table.filter(t,e)
return e and not cbimap.uci:get_bool("asterisk",e,"provider")
end
function sip_table.create(t,e)
if TypedSection.create(t,e)then
created=e
cbimap.uci:tset("asterisk",e,{
type="friend",
qualify="yes",
provider="no",
host="dynamic",
nat="no",
canreinvite="no",
extension=e:match("^%d+$")and e or"",
username=e:match("^%d+$")and e or""
})
else
t.invalid_cts=true
end
end
function sip_table.parse(e,...)
TypedSection.parse(e,...)
if created then
cbimap.uci:save("asterisk")
luci.http.redirect(luci.dispatcher.build_url(
"admin","asterisk","phones","sip",created
))
end
end
user=sip_table:option(DummyValue,"username","Username")
function user.cfgvalue(a,t)
return e[t]and e[t].callerid or
AbstractValue.cfgvalue(a,t)
end
host=sip_table:option(DummyValue,"host","Hostname")
function host.cfgvalue(a,t)
if e[t]and e[t].info.address then
return"%s:%i"%{e[t].info.address,e[t].info.port}
else
return"n/a"
end
end
context=sip_table:option(DummyValue,"context","Dialplan")
context.href=luci.dispatcher.build_url("admin","asterisk","dialplan")
online=sip_table:option(DummyValue,"online","Registered")
function online.cfgvalue(a,t)
if e[t]and e[t].info.online==nil then
return"n/a"
else
return e[t]and e[t].info.online
and"yes"or"no (%s)"%{
e[t]and e[t].info.Status:lower()or"unknown"
}
end
end
delay=sip_table:option(DummyValue,"delay","Delay")
function delay.cfgvalue(a,t)
if e[t]and e[t].info.online then
return"%i ms"%e[t].info.delay
else
return"n/a"
end
end
info=sip_table:option(Button,"_info","Info")
function info.write(t,e)
luci.http.redirect(luci.dispatcher.build_url(
"admin","asterisk","phones","sip",e,"info"
))
end
return cbimap
