local a=require("luci.asterisk")
cbimap=Map("asterisk","Trunks")
cbimap.pageaction=false
local e={}
cbimap.uci:foreach("asterisk","sip",
function(t)
if t.type=="peer"then
t.name=t['.name']
t.info=a.sip.peer(t.name)
e[t.name]=t
end
end)
sip_table=cbimap:section(TypedSection,"sip","SIP Trunks")
sip_table.template="cbi/tblsection"
sip_table.extedit=luci.dispatcher.build_url("admin","asterisk","trunks","sip","%s")
sip_table.addremove=true
sip_table.sectionhead="Extension"
function sip_table.filter(t,e)
return e and(
cbimap.uci:get("asterisk",e,"type")==nil or
cbimap.uci:get_bool("asterisk",e,"provider")
)
end
function sip_table.create(e,t)
if TypedSection.create(e,t)then
created=t
else
e.invalid_cts=true
end
end
function sip_table.parse(e,...)
TypedSection.parse(e,...)
if created then
cbimap.uci:tset("asterisk",created,{
type="friend",
qualify="yes",
provider="yes"
})
cbimap.uci:save("asterisk")
luci.http.redirect(luci.dispatcher.build_url(
"admin","asterisk","trunks","sip",created
))
end
end
user=sip_table:option(DummyValue,"username","Username")
context=sip_table:option(DummyValue,"context","Dialplan")
context.href=luci.dispatcher.build_url("admin","asterisk","dialplan")
function context.cfgvalue(...)
return AbstractValue.cfgvalue(...)or"(default)"
end
online=sip_table:option(DummyValue,"online","Registered")
function online.cfgvalue(a,t)
if e[t]and e[t].info.online==nil then
return"n/a"
else
return e[t]and e[t].info.online
and"yes"or"no (%s)"%{
e[t]and e[t].info.Status:lower()or"unknown"
}
end
end
delay=sip_table:option(DummyValue,"delay","Delay")
function delay.cfgvalue(a,t)
if e[t]and e[t].info.online then
return"%i ms"%e[t].info.delay
else
return"n/a"
end
end
info=sip_table:option(Button,"_info","Info")
function info.write(t,e)
luci.http.redirect(luci.dispatcher.build_url(
"admin","asterisk","trunks","sip",e,"info"
))
end
return cbimap
